Package tigase.workgroupqueues.modules.agent

## Class PresenceModule

- java.lang.Object
- - tigase.workgroupqueues.modules.AbstractModule
  - - tigase.workgroupqueues.modules.agent.PresenceModule

- All Implemented Interfaces:
    `Module`

      @Bean(name="AgentPresenceModule",
            active=true)
      public class PresenceModule
      extends AbstractModule

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ID` |

    - ### Fields inherited from class tigase.workgroupqueues.modules.AbstractModule

      `writer, XMLNS`

    - ### Fields inherited from interface tigase.component.modules.Module

      `EMPTY_FEATURES`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PresenceModule()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String[]` | `getFeatures()` | Returns XMPP features offered by module.
    `Criteria` | `getModuleCriteria()` | Returns critera used by Component to select module to handle incoming stanza.
    `void` | `process​(Packet packet)` | Process incoming stanza.
    `void` | `sendAgentStatusUpdate​(Agent agent)` | Workgroup Status Update.
    `void` | `sendPresenceUpdateOf​(Agent agent)` |
    `void` | `sendQueueStatusDetailsUpdate​(Agent agent)` | Queue Status Update.
    `void` | `sendQueueStatusUpdate​(Agent agent)` | Queue Status Update.

    - ### Methods inherited from class tigase.workgroupqueues.modules.AbstractModule

      `write, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface tigase.component.modules.Module

      `canHandle`

- - ### Field Detail

    - #### ID

          public static final java.lang.String ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PresenceModule

          public PresenceModule()

  - ### Method Detail

    - #### getFeatures

          public java.lang.String[] getFeatures()

      Description copied from interface: `Module`
      Returns XMPP features offered by module. Features will be returned by Service Discovery.
      Returns:
        array of features or `null`.

    - #### getModuleCriteria

          public Criteria getModuleCriteria()

      Description copied from interface: `Module`
      Returns critera used by Component to select module to handle incoming stanza.
      Returns:
        criteria of selecting module.

    - #### process

          public void process​(Packet packet)
                       throws ComponentException,
                              TigaseStringprepException

      Description copied from interface: `Module`
      Process incoming stanza.
      Parameters:
        `packet` - received `stanza`.
      Throws:
        `ComponentException` - if stanza can't be processed correctly. ComponentException is converted to error stanza and returned to stanza sender.
        `TigaseStringprepException` - if there was an error during stringprep processing.

    - #### sendAgentStatusUpdate

          public void sendAgentStatusUpdate​(Agent agent)
                                     throws TigaseStringprepException

      Workgroup Status Update. Update agents on the status of the workgroup.
      Parameters:
        `agent` - agent to send update.
      Throws:
        `TigaseStringprepException` - in case of invalid JID.

    - #### sendPresenceUpdateOf

          public void sendPresenceUpdateOf​(Agent agent)
                                    throws TigaseStringprepException

      Throws:
        `TigaseStringprepException`

    - #### sendQueueStatusDetailsUpdate

          public void sendQueueStatusDetailsUpdate​(Agent agent)
                                            throws TigaseStringprepException

      Queue Status Update.
      Parameters:
        `agent` - agent to which update will be sent.
      Throws:
        `TigaseStringprepException` - in case of invalid JID.

    - #### sendQueueStatusUpdate

          public void sendQueueStatusUpdate​(Agent agent)
                                     throws TigaseStringprepException

      Queue Status Update.
      Parameters:
        `agent` - agent to which update will be sent.
      Throws:
        `TigaseStringprepException` - in case of invalid JID.